"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = generateModuleFiles;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _lodash = _interopRequireDefault(require("lodash"));

var _chalk = _interopRequireDefault(require("chalk"));

var _path = _interopRequireDefault(require("path"));

var _writeFiles = _interopRequireDefault(require("./writeFiles"));

var _model = _interopRequireDefault(require("../templates/server/model"));

var _controller = _interopRequireDefault(require("../templates/server/controller"));

var _template = _interopRequireDefault(require("../templates/server/template"));

var _model2 = _interopRequireDefault(require("../templates/shared/models/model"));

var _schema = _interopRequireDefault(require("../templates/shared/models/schema"));

var _actions = _interopRequireDefault(require("../templates/shared/module/actions"));

var _reducer = _interopRequireDefault(require("../templates/shared/module/reducer"));

var _selectors = _interopRequireDefault(require("../templates/shared/module/selectors"));

var _ExampleModelForm = _interopRequireDefault(require("../templates/shared/module/components/forms/ExampleModelForm"));

var _ExampleModelCreate = _interopRequireDefault(require("../templates/shared/module/components/ExampleModelCreate"));

var _ExampleModelDetail = _interopRequireDefault(require("../templates/shared/module/components/ExampleModelDetail"));

var _ExampleModelEdit = _interopRequireDefault(require("../templates/shared/module/components/ExampleModelEdit"));

var _ExampleModelList = _interopRequireDefault(require("../templates/shared/module/components/ExampleModelList"));

var _ExampleModelCreate2 = _interopRequireDefault(require("../templates/shared/module/containers/ExampleModelCreate"));

var _ExampleModelDetail2 = _interopRequireDefault(require("../templates/shared/module/containers/ExampleModelDetail"));

var _ExampleModelEdit2 = _interopRequireDefault(require("../templates/shared/module/containers/ExampleModelEdit"));

var _ExampleModelList2 = _interopRequireDefault(require("../templates/shared/module/containers/ExampleModelList"));

// eslint-disable-line
// eslint-disable-line
function generateModuleFiles(_x, _x2) {
  return _generateModuleFiles.apply(this, arguments);
}

function _generateModuleFiles() {
  _generateModuleFiles = (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(model, options) {
    var output;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            output = [{
              path: _path["default"].join(options.root, "server/models/".concat(model.className, ".js")),
              content: (0, _model["default"])(model)
            }, {
              path: _path["default"].join(options.root, "server/api/controllers/".concat(model.classPlural, ".js")),
              content: (0, _controller["default"])(model)
            }, {
              path: _path["default"].join(options.root, "server/api/templates/".concat(model.variablePlural, "/base.js")),
              content: (0, _template["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/models/".concat(model.className, ".js")),
              content: (0, _model2["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/models/schemas/".concat(model.variableName, ".js")),
              content: (0, _schema["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/actions.js")),
              content: (0, _actions["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/reducer.js")),
              content: (0, _reducer["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/selectors.js")),
              content: (0, _selectors["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/components/forms/").concat(model.className, "Form.js")),
              content: (0, _ExampleModelForm["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "Create.js")),
              content: (0, _ExampleModelCreate["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "Detail.js")),
              content: (0, _ExampleModelDetail["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "Edit.js")),
              content: (0, _ExampleModelEdit["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/components/").concat(model.className, "List.js")),
              content: (0, _ExampleModelList["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "Create.js")),
              content: (0, _ExampleModelCreate2["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "Detail.js")),
              content: (0, _ExampleModelDetail2["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "Edit.js")),
              content: (0, _ExampleModelEdit2["default"])(model)
            }, {
              path: _path["default"].join(options.root, "shared/modules/".concat(model.variablePlural, "/containers/").concat(model.className, "List.js")),
              content: (0, _ExampleModelList2["default"])(model)
            }];
            _context.next = 3;
            return (0, _writeFiles["default"])(output, options);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _generateModuleFiles.apply(this, arguments);
}

module.exports = exports.default;