"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _util = require("util");

/* eslint-disable no-bitwise */
function replaceString(fileName, oldStr, newStr, callback) {
  _fs["default"].access(fileName, _fs["default"].W_OK | _fs["default"].R_OK, function (err) {
    if (err) return callback(new Error("String replacement failure: ".concat(err)));

    _fs["default"].readFile(fileName, function (err, data) {
      //read old file
      if (err) return callback(new Error("String replacement failure: ".concat(err)));
      var txt = data.toString();
      var replacedTxt = txt.replace(oldStr, newStr);

      _fs["default"].writeFile(fileName + '_tmp', replacedTxt, function (err) {
        //write tmp file
        if (err) return callback(new Error("String replacement failure: ".concat(err)));

        _fs["default"].unlink(fileName, function (err) {
          //delete old file
          if (err) return callback(new Error("String replacement failure: ".concat(err)));

          _fs["default"].rename(fileName + '_tmp', fileName, function (err) {
            // rename tmp file
            if (err) return callback(new Error("String replacement failure: ".concat(err)));
            return callback(null);
          });
        });
      });
    });
  });
}

var _default = (0, _util.promisify)(replaceString);

exports["default"] = _default;
module.exports = exports.default;