"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.writeFile = writeFile;
exports["default"] = writeFiles;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _mkdirp = _interopRequireDefault(require("mkdirp"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _chalk = _interopRequireDefault(require("chalk"));

var _util = require("util");

var writeFileAsync = (0, _util.promisify)(_fs["default"].writeFile);

function writeFile(_x, _x2) {
  return _writeFile.apply(this, arguments);
}

function _writeFile() {
  _writeFile = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(out, options) {
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(!options.force && _fs["default"].existsSync(out.path))) {
              _context.next = 2;
              break;
            }

            throw new Error("File already exists at ".concat(out.path, ". Use --force to overwrite"));

          case 2:
            _context.next = 4;
            return (0, _mkdirp["default"])(_path["default"].dirname(out.path));

          case 4:
            console.log(' ', _chalk["default"].green('Creating file:'), out.path);

            if (options.verbose) {
              console.log('---------------------');
              console.log(_chalk["default"].yellow(out.content));
              console.log('---------------------');
            }

            _context.next = 8;
            return writeFileAsync(out.path, out.content);

          case 8:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _writeFile.apply(this, arguments);
}

function writeFiles(_x3, _x4) {
  return _writeFiles.apply(this, arguments);
}

function _writeFiles() {
  _writeFiles = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(output, options) {
    var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, out;

    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 3;
            _iterator = output[Symbol.iterator]();

          case 5:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 12;
              break;
            }

            out = _step.value;
            _context2.next = 9;
            return writeFile(out, options);

          case 9:
            _iteratorNormalCompletion = true;
            _context2.next = 5;
            break;

          case 12:
            _context2.next = 18;
            break;

          case 14:
            _context2.prev = 14;
            _context2.t0 = _context2["catch"](3);
            _didIteratorError = true;
            _iteratorError = _context2.t0;

          case 18:
            _context2.prev = 18;
            _context2.prev = 19;

            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }

          case 21:
            _context2.prev = 21;

            if (!_didIteratorError) {
              _context2.next = 24;
              break;
            }

            throw _iteratorError;

          case 24:
            return _context2.finish(21);

          case 25:
            return _context2.finish(18);

          case 26:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, null, [[3, 14, 18, 26], [19,, 21, 25]]);
  }));
  return _writeFiles.apply(this, arguments);
}