#!/usr/bin/env node
"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _commander = _interopRequireDefault(require("commander"));

var _chalk = _interopRequireDefault(require("chalk"));

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _createProject = _interopRequireDefault(require("./commands/createProject"));

var _createModel = _interopRequireDefault(require("./commands/createModel"));

var _createSchema = _interopRequireDefault(require("./commands/createSchema"));

function inCorrectDirectory() {
  return _fs["default"].existsSync(_path["default"].resolve(process.cwd(), 'client')) && _fs["default"].existsSync(_path["default"].resolve(process.cwd(), 'server')) && _fs["default"].existsSync(_path["default"].resolve(process.cwd(), 'shared'));
}

_commander["default"].version('0.0.1').option('-l, --verbose', 'Show more information when the command is being excecuted').option('-d, --dry_run', 'A dry_run run which will only list the effected records/files').option('-f, --force', 'Force');

_commander["default"].command('add-model <name>').alias('m').description('Create a new model in the current app').action( /*#__PURE__*/function () {
  var _ref = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee(name) {
    var options;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = {
              name: name,
              root: process.cwd(),
              force: _commander["default"].force,
              verbose: _commander["default"].verbose
            };

            if (!(!options.force && !inCorrectDirectory())) {
              _context.next = 3;
              break;
            }

            return _context.abrupt("return", console.log(_chalk["default"].red("This command should be run from the root directory of Frameworkstein web apps")));

          case 3:
            console.log("Creating model ".concat(_chalk["default"].blue(name), " with options"), options);
            _context.next = 6;
            return (0, _createModel["default"])(options);

          case 6:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}());

_commander["default"].command('add-models <filename>').alias('schema').alias('models').description('Generate model files from a graphql schema definition file').action( /*#__PURE__*/function () {
  var _ref2 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee2(filename) {
    var options;
    return _regenerator["default"].wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            options = {
              filename: _path["default"].join(process.cwd(), filename),
              root: process.cwd(),
              force: _commander["default"].force,
              verbose: _commander["default"].verbose
            };

            if (!(!options.force && !inCorrectDirectory())) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt("return", console.log(_chalk["default"].red("This command should be run from the root directory of Frameworkstein web apps")));

          case 3:
            console.log("Creating models from file ".concat(_chalk["default"].green(filename), " with options"), options);
            _context2.next = 6;
            return (0, _createSchema["default"])(options);

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function (_x2) {
    return _ref2.apply(this, arguments);
  };
}());

_commander["default"].command('new-web <name>').alias('new').description('Create a new web app').option('-t, --type', 'Type').action( /*#__PURE__*/function () {
  var _ref3 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee3(name) {
    var options;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            options = {
              name: name,
              type: 'web',
              root: process.cwd(),
              force: _commander["default"].force,
              verbose: _commander["default"].verbose
            };
            console.log("Creating new web app ".concat(_chalk["default"].green(name), " with options"), options);
            _context3.next = 4;
            return (0, _createProject["default"])(options);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));

  return function (_x3) {
    return _ref3.apply(this, arguments);
  };
}());

_commander["default"].command('new-mobile <name>').description('Create a new mobile app').option('-t, --type', 'Type').action( /*#__PURE__*/function () {
  var _ref4 = (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee4(name) {
    var options;
    return _regenerator["default"].wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            options = {
              name: name,
              type: 'mobile',
              root: process.cwd(),
              force: _commander["default"].force,
              verbose: _commander["default"].verbose
            };
            console.log("Creating new mobile app ".concat(_chalk["default"].green(name), " with options"), options);
            _context4.next = 4;
            return (0, _createProject["default"])(options);

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));

  return function (_x4) {
    return _ref4.apply(this, arguments);
  };
}());

_commander["default"].parse(process.argv);