"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parseModelsFromSchema = parseModelsFromSchema;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _lodash = _interopRequireDefault(require("lodash"));

var _commander = _interopRequireDefault(require("commander"));

var _graphql = require("graphql");

var _dataTypes = require("./dataTypes");

var _modelNames = _interopRequireDefault(require("./modelNames"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function parseModelsFromSchema(schema) {
  var parsedSchema = (0, _graphql.parse)(schema);
  var models = [];
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = parsedSchema.definitions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var definition = _step.value;
      var model = {
        name: definition.name.value,
        root: process.cwd() + '/api-test',
        force: _commander["default"].force,
        verbose: _commander["default"].verbose,
        modelType: definition.name.value
      };
      var fields = [];
      var relations = [];
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = definition.fields[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var field = _step2.value;
          var modelType = field.type.type ? (0, _dataTypes.translateType)(field.type.type.name.value) : (0, _dataTypes.translateType)(field.type.name.value);

          if ((0, _dataTypes.isCustomObject)(modelType)) {
            fields.push({
              name: field.name.value
            });
            relations.push({
              name: field.name.value,
              modelType: modelType,
              relationType: field.type.kind === 'ListType' ? 'hasMany' : 'belongsTo'
            });
          } else if (field.name.value !== 'id') {
            fields.push({
              name: field.name.value,
              type: modelType
            });
          }

          model = _objectSpread({}, model, {
            fields: fields,
            relations: relations
          });
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
            _iterator2["return"]();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      model = _objectSpread({}, model, {}, (0, _modelNames["default"])(model.name));
      models.push(model);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var _loop = function _loop() {
    var model = _models[_i];
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      var _loop2 = function _loop2() {
        var relation = _step3.value;
        relation.model = _lodash["default"].find(models, function (m) {
          return m.modelType === relation.modelType;
        });

        if (relation.relationType === 'hasMany') {
          var reverseRelation = _lodash["default"].find(relation.model.relations, function (m) {
            return m.modelType === model.modelType;
          });

          if (reverseRelation.relationType === 'hasMany') relation.m2m = true;
        }
      };

      for (var _iterator3 = model.relations[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        _loop2();
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
          _iterator3["return"]();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }
  };

  for (var _i = 0, _models = models; _i < _models.length; _i++) {
    _loop();
  }

  return models;
}