"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.label = label;
exports["default"] = void 0;

var _inflection = _interopRequireDefault(require("inflection"));

function label(key) {
  return _inflection["default"].humanize(_inflection["default"].underscore(key));
}

var _default = function _default(model) {
  return "import React from 'react'\nimport PropTypes from 'prop-types'\nimport { reduxForm, Field } from 'redux-form'\nimport { Input, HasManyInput, BelongsToInput, ManyToManyInput } from 'fl-react-utils'\nimport Button from '../../../utils/components/Button'\nimport ".concat(model.className, " from '../../../../models/").concat(model.className, "'\n\n\n@reduxForm({\n  form: '").concat(model.variableName, "Form',\n})\nexport default class ").concat(model.className, "Form extends React.PureComponent {\n\n  static propTypes = {\n    loading: PropTypes.bool,\n    handleSubmit: PropTypes.func.isRequired,\n    ").concat(model.variableName, ": PropTypes.object,\n\n    // Relations\n    ").concat(model.relations.map(function (relation) {
    return "".concat(relation.model.variablePlural, ": PropTypes.array,");
  }).join('\n    '), "\n  }\n\n  render() {\n    const { loading, handleSubmit, ").concat(model.variableName, ", ").concat(model.relations.map(function (relation) {
    return relation.model.variablePlural;
  }).join(', '), " } = this.props\n\n    return (\n      <form onSubmit={handleSubmit}>\n").concat(model.fields.map(function (field) {
    return "\n        <Field\n          name=\"".concat(field.name, "\"\n          label=\"").concat(label(field.name), "\"\n          component={Input}\n        />\n");
  }).join(''), "\n").concat(model.relations.map(function (relation) {
    if (relation.m2m) {
      return "\n        <Field\n          {...this.props}\n          name=\"".concat(relation.name, "\"\n          label=\"").concat(label(relation.name), "\"\n          path=\"/").concat(relation.model.variablePlural, "\"\n          model={").concat(model.variableName, "}\n          models={").concat(relation.model.variablePlural, "}\n          component={ManyToManyInput}\n          relation={").concat(model.className, ".schema.relations.").concat(relation.name, "}\n        />");
    }

    if (relation.relationType === 'hasMany') {
      return "\n        <Field\n          name=\"".concat(relation.name, "\"\n          label=\"").concat(label(relation.name), "\"\n          path=\"/").concat(relation.model.variablePlural, "\"\n          models={").concat(relation.model.variablePlural, "}\n          component={HasManyInput}\n        />");
    }

    if (relation.relationType === 'belongsTo') {
      return "\n        <Field\n          name=\"".concat(relation.name, "\"\n          label=\"").concat(label(relation.name), "\"\n          models={").concat(relation.model.variablePlural, "}\n          component={BelongsToInput}\n        />");
    }

    return '';
  }).join(''), "\n\n        <div className=\"text-center mt-5\">\n          <Button loading={loading} type=\"submit\" size=\"lg\">Save</Button>\n        </div>\n      </form>\n    )\n  }\n}\n");
};

exports["default"] = _default;