"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

/* eslint-disable */
var _default = function _default(options) {
  return "import _ from 'lodash'\nimport React from 'react'\nimport PropTypes from 'prop-types'\nimport Helmet from 'react-helmet'\nimport { connect } from 'react-redux'\nimport { push } from 'connected-react-router'\nimport { load".concat(options.classPlural, ", save").concat(options.className, ", delete").concat(options.className, ", update").concat(options.className, ", linkRelation, unlinkRelation } from '../actions'\nimport { select").concat(options.className, ", select").concat(options.classPlural, "Error } from '../selectors'\nimport ").concat(options.className, "Edit from '../components/").concat(options.className, "Edit'\nimport Loader from '../../utils/components/Loader'\n").concat(options.relations.map(function (relation) {
    if (relation.m2m) {
      return "import { load".concat(relation.model.classPlural, ", update").concat(relation.model.className, " } from '../../").concat(relation.model.variablePlural, "/actions'\n");
    }

    return "import { load".concat(relation.model.classPlural, " } from '../../").concat(relation.model.variablePlural, "/actions'\n");
  }).join(''), "\n\n@connect((state, props) => ({\n  ").concat(options.variableName, ": select").concat(options.className, "(state, props),\n  errorMsg: select").concat(options.classPlural, "Error(state, 'save'),\n  loading: state.").concat(options.variablePlural, ".get('loading'),").concat(options.relations.map(function (relation) {
    if (relation.m2m) {
      return "\n  ".concat(relation.model.variablePlural, "Store: state.").concat(relation.model.variablePlural, ",");
    }

    if (relation.relationType === 'belongsTo') {
      return "\n  ".concat(relation.model.variablePlural, ": _.values(state.").concat(relation.model.variablePlural, ".get('models').toJSON()),");
    }

    return "\n  ".concat(relation.model.variablePlural, ": _(state.").concat(relation.model.variablePlural, ".get('models').toJSON()).values().filter(m => m.").concat(options.variableName, "_id == props.match.params.id).value(),");
  }).join(''), "\n}), {\n  save").concat(options.className, ",\n  delete").concat(options.className, ",\n  push,\n  linkRelation,\n  unlinkRelation,").concat(options.relations.map(function (relation) {
    return relation.m2m ? "\n  update".concat(relation.model.className, ",") : '';
  }).join(''), "\n})\nexport default class ").concat(options.classPlural, "EditContainer extends React.PureComponent {\n\n  static propTypes = {\n    ").concat(options.variableName, ": PropTypes.object,\n    errorMsg: PropTypes.string,\n    loading: PropTypes.bool,\n    save").concat(options.className, ": PropTypes.func.isRequired,\n    delete").concat(options.className, ": PropTypes.func.isRequired,\n    push: PropTypes.func.isRequired,\n\n    linkRelation: PropTypes.func.isRequired,\n    unlinkRelation: PropTypes.func.isRequired,").concat(options.relations.map(function (relation) {
    return relation.m2m ? "\n    update".concat(relation.model.className, ": PropTypes.func.isRequired,") : '';
  }).join(''), "\n\n    // Relations").concat(options.relations.map(function (relation) {
    if (relation.m2m) {
      return "\n    ".concat(relation.model.variablePlural, "Store: PropTypes.object.isRequired,");
    }

    return "\n    ".concat(relation.model.variablePlural, ": PropTypes.array.isRequired,");
  }).join(''), "\n  }\n\n  static async fetchData({store, match}) {\n    try {\n      let ").concat(options.variableName, " = select").concat(options.className, "(store.getState(), {match})\n      const id = match.params.id\n\n      if (!").concat(options.variableName, ") {\n        const action = await store.dispatch(load").concat(options.classPlural, "({id}))\n        ").concat(options.variableName, " = action.model\n\n        if (!").concat(options.variableName, ") {\n          console.log('No ").concat(options.variableName, " found for params:', match.params)\n          return {status: 404}\n        }\n      }").concat(options.relations.map(function (relation) {
    if (relation.m2m) {
      return "\n\n      // load m2m\n      const ".concat(relation.name, "Action = await store.dispatch(load").concat(relation.model.classPlural, "({").concat(options.variableName, "_id: id}))\n      // set related ids\n      store.dispatch(update").concat(options.className, "({id, ").concat(relation.model.variableName, "_ids: ").concat(relation.name, "Action.ids}))");
    }

    if (relation.relationType === 'belongsTo') {
      return "\n\n      // load all models for belongsTo selector\n      await store.dispatch(load".concat(relation.model.variablePlural, "({}))");
    }

    return "\n\n      // load related hasMany models\n      await store.dispatch(load".concat(relation.model.variablePlural, "({").concat(options.variableName, "_id: id}))");
  }).join(''), "\n    }\n    catch (err) {\n      console.log(err)\n    }\n  }\n\n  handleSubmit = async data => {\n    try {\n      const action = await this.props.save").concat(options.className, "(data)\n      const ").concat(options.variableName, " = action.model\n      if (").concat(options.variableName, ".id) this.props.push(`/").concat(options.variablePlural, "/${").concat(options.variableName, ".id}`)\n    }\n    catch (err) {\n      return console.error(err)\n    }\n  }\n\n  handleDelete = async data => {\n    try {\n      await this.props.delete").concat(options.className, "(data)\n      this.props.push('/").concat(options.variablePlural, "')\n    }\n    catch (err) {\n      return console.error(err)\n    }\n  }\n\n  handleLinkRelation = (relatedModel, relationField, idsKey) => {\n    this.props.update").concat(options.className, "(relatedModel)\n    this.props.linkRelation(this.props.").concat(options.variableName, ", relationField, idsKey, relatedModel.id)\n  }\n  handleUnlinkRelation = (relatedModel, relationField, idsKey) => {\n    this.props.unlinkRelation(this.props.").concat(options.variableName, ", relationField, idsKey, relatedModel.id)\n  }\n\n  render() {\n    const { ").concat(options.variableName, ", loading, errorMsg } = this.props\n    if (!").concat(options.variableName, ") return <Loader />\n\n    return (\n      <div>\n        <Helmet title=\"Edit an ").concat(options.className, "\" />\n        <").concat(options.className, "Edit\n          ").concat(options.variableName, "={").concat(options.variableName, "}\n          loading={loading}\n          errorMsg={errorMsg}\n          onSubmit={this.handleSubmit}\n          onDelete={this.handleDelete}\n          onLinkRelation={this.handleLinkRelation}\n          onUnlinkRelation={this.handleUnlinkRelation}\n\n          // Relations").concat(options.relations.map(function (relation) {
    if (relation.m2m) {
      return "\n          ".concat(relation.model.variablePlural, "={_(").concat(options.variableName, ".").concat(relation.model.variableName, "_ids).map(id => this.props.").concat(relation.model.variablePlural, "Store.get('models').get(id) && this.props.").concat(relation.model.variablePlural, "Store.get('models').get(id).toJSON()).compact().value()}");
    }

    return "\n          ".concat(relation.model.variablePlural, "={this.props.").concat(relation.model.variablePlural, "}");
  }).join(''), "\n        />\n      </div>\n    )\n  }\n}\n");
}; // // orders belongsTo ${options.variableName} or m2m
// const ordersAction = await store.dispatch(loadOrders({${options.variableName}_id: id}))
// // // set related ids if m2m
// // store.dispatch(update${options.className}({id, order_ids: ordersAction.ids}))
// // orders belongsTo ${options.variableName} or m2m
// const profileAction = await store.dispatch(loadProfiles({}))
// // orders belongsTo ${options.variableName} or m2m
// const manyModelsAction = await store.dispatch(loadManyModels({${options.variableName}_id: id}))
// // set related ids if m2m
// store.dispatch(update${options.className}({id, manyModel_ids: manyModelsAction.ids}))


exports["default"] = _default;
module.exports = exports.default;