"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _default = function _default(options) {
  return "import _ from 'lodash' // eslint-disable-line\nimport { fromJS } from 'immutable'\nimport { removeModel, updateModel } from 'fl-redux-utils'\nimport { TYPES } from './actions'\n\n\nconst defaultState = fromJS({\n  loading: false,\n  loaded: false,\n  errors: {},\n  models: {},\n  modelList: [],\n})\n\nexport default function reducer(state=defaultState, action={}) {\n\n  switch (action.type) {\n    case TYPES.".concat(options.actionName, "_LOAD + '_START':\n    case TYPES.").concat(options.actionName, "_SAVE + '_START':\n    case TYPES.").concat(options.actionName, "_DELETE + '_START':\n      return state.merge({loading: true, errors: {}})\n\n    case TYPES.").concat(options.actionName, "_LOAD + '_ERROR':\n      return state.merge({loading: false, error: {load: action.error || action.res.error}})\n    case TYPES.").concat(options.actionName, "_SAVE + '_ERROR':\n      return state.merge({loading: false, error: {save: action.error || action.res.error}})\n    case TYPES.").concat(options.actionName, "_DELETE + '_ERROR':\n      return state.merge({loading: false, error: {delete: action.error || action.res.error}})\n\n    case TYPES.").concat(options.actionName, "_LOAD +'_SUCCESS':\n      return state.merge({\n        loading: false,\n        errors: {},\n        loaded: true,\n      }).mergeDeep({\n        models: action.models,\n        modelList: action.modelList,\n      })\n\n    case TYPES.").concat(options.actionName, "_SAVE + '_SUCCESS':\n      return updateModel(state, action.model)\n\n    case TYPES.").concat(options.actionName, "_DELETE + '_SUCCESS':\n      return removeModel(state, action.deletedModel.id)\n\n    case TYPES.").concat(options.actionName, "_LOCAL_UPDATE:\n      const uModel = state.get('models').get(action.model.id) && state.get('models').get(action.model.id).toJSON()\n      if (!uModel) return state\n      return state.setIn(['models', action.model.id], fromJS(_.merge(uModel, action.model)))\n\n    case TYPES.").concat(options.actionName, "_LINK_RELATION + '_START':\n      return state.merge({\n        errors: {},\n      })\n    case TYPES.").concat(options.actionName, "_LINK_RELATION + '_ERROR':\n      return state.merge({loading: false, errors: {link: action.error || action.res.body.error}})\n\n    case TYPES.").concat(options.actionName, "_LINK_RELATION + '_SUCCESS':\n      const model = state.get('models').get(action.modelId).toJSON()\n      model[action.idsKey] = _.uniq([...(model[action.idsKey] || []), action.relatedModelId])\n      return state.setIn(['models', action.modelId], fromJS(model))\n\n    case TYPES.").concat(options.actionName, "_UNLINK_RELATION + '_SUCCESS':\n      const removingFromModel = state.get('models').get(action.modelId).toJSON()\n      removingFromModel[action.idsKey] = _.without(removingFromModel[action.idsKey] || [], action.relatedModelId)\n      return state.setIn(['models', action.modelId], fromJS(removingFromModel))\n\n    default:\n      return state\n  }\n}\n");
};

exports["default"] = _default;
module.exports = exports.default;