"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _default = function _default(options) {
  return "import Immutable from 'immutable'\nimport { combineReducers } from 'redux'\nimport { reducer as form } from 'redux-form'\nimport { reducer as admin } from 'fl-admin'\nimport { connectRouter } from 'connected-react-router'\nimport app from './modules/app/reducer'\nimport auth from './modules/users/reducers/auth'\nimport profiles from './modules/users/reducers/profiles'\n".concat(options.models.map(function (modelOption) {
    return "import ".concat(modelOption.variablePlural, " from './modules/").concat(modelOption.variablePlural, "/reducer'\n");
  }).join(''), "\n\nexport function createReducer(history) {\n  return combineReducers({\n    app,\n    auth,\n    form,\n    profiles,").concat(options.models.map(function (modelOption) {
    return "\n    ".concat(modelOption.variablePlural, ",");
  }).join(''), "\n    router: connectRouter(history),\n    admin: admin || ((state=new Immutable.Map()) => state),\n    config: (state=new Immutable.Map()) => state,\n  })\n}\n");
};

exports["default"] = _default;
module.exports = exports.default;